import java.util.*;
import java.io.*;

public class turtles_as {
    FastScanner in;
    PrintWriter out;

    public void solve() throws IOException {
        int h = in.nextInt();
        int w = in.nextInt();
        int bad = 0;
        int[] horMin = new int[h];
        int[] verMin = new int[w];
        Arrays.fill(horMin, w);
        Arrays.fill(verMin, h);
        int[] horMax = new int[h];
        int[] verMax = new int[w];
        Arrays.fill(horMax, -1);
        Arrays.fill(verMax, -1);
        int[] horCnt = new int[h];
        int[] verCnt = new int[w];

        int n = in.nextInt();
        int cur = 0;
        boolean print = false;
        while (cur < n) {
            cur++;
            int r = in.nextInt() - 1;
            int c = in.nextInt() - 1;
            if (verMax[c] == -1 || verMax[c] - verMin[c] + 1 == verCnt[c]) {
                bad++;
            }
            if (horMax[r] == -1 || horMax[r] - horMin[r] + 1 == horCnt[r]) {
                bad++;
            }
            if (r < verMin[c]) {
                verMin[c] = r;
            }
            if (r > verMax[c]) {
                verMax[c] = r;
            }
            if (c < horMin[r]) {
                horMin[r] = c;
            }
            if (c > horMax[r]) {
                horMax[r] = c;
            }
            horCnt[r]++;
            verCnt[c]++;
            if (verMax[c] - verMin[c] + 1 == verCnt[c]) {
                bad--;
            }
            if (horMax[r] - horMin[r] + 1 == horCnt[r]) {
                bad--;
            }
            if (!print && cur == n) {
                n += in.nextInt();
                print = true;
            }
            if (print) {
                if (bad == 0) {
                    out.println("YES");
                } else {
                    out.println("NO");
                }
            }
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File("turtles.in"));
            out = new PrintWriter(new File("turtles.out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new turtles_as().run();
    }
}